// =======================================
// GLOBAL VARIABLES
// =======================================

 var food  = 60;			// Food status, start at half		
 var water = 60;			// Water status, start at half
 var love  = 60;			// Love status, start at half
 
 var timerInterval;
 var time  = 0;			// Time of the day
 
 var moodString = "Happy";  // Current mood

 var useSound = true;		// Sound pref
 var speedFactor = 2.0;		// User defined speed, for demo purposes set to 0.5 to speed things up a bit
 var feelingFactor = 1.0;	// Impact of well-beingness
 

// =======================================
// GRAPHICS
// =======================================
 
 var eyesopenfull = new Image (31, 22);
 eyesopenfull.src = 'Images/eyesopenfull.png';

 var eyesopenhalf = new Image (31, 22);
 eyesopenhalf.src = 'Images/eyesopenhalf.png';
 
 var hungry = new Image (44, 42);
 hungry.src = 'Images/hungry.png';
 
 var full = new Image (88, 72);
 full.src = 'Images/full.png';

 var mouthhappy = new Image (33, 34);
 mouthhappy.src = 'Images/mouthhappy.png';
 
 var mouththirstyoff = new Image (33, 34);
 mouththirstyoff.src = 'Images/mouththirstyoff.png';
 
 var mouththirstyon = new Image (33, 34);
 mouththirstyon.src = 'Images/mouththirstyon.png';
 
 var tailhappy = new Image (37, 47);
 tailhappy.src = 'Images/tailhappy.png'; 
 
 var taillazy = new Image (37, 47);
 taillazy.src = 'Images/taillazy.png'; 
 

// =======================================
// SOUNDS
// =======================================

function playSound(soundobj){
	var thissound = document.getElementById(soundobj);
	thissound.Play();
}


// =======================================
// KEYS
// =======================================


// =======================================
// SETUP METHODS
// =======================================

function gotchiLoaded() {

	// Preference
	
	if (window.widget){
		var pref = widget.preferenceForKey('playsound');
		if (pref && pref.length > 0){ 
			if(pref == 'usesound'){
			 useSound = true;
			}else{
			 useSound = false;
			}
		}
	}

	document.settings.sound.checked = useSound;

	// Timer
	timerInterval = setInterval("updateScore(true);", 1000);
	if(useSound) playSound("sound_harp");
}


// =======================================
// ACCESSOR METHODS
// =======================================

function isDead()
{		
	return food < 1 || water < 1 || love < 1;
}


// =======================================
// SCORE METHODS
// =======================================

function updateScore(triggered) {
	
	// UPDATE SCORES
	food	=	food  - 0.01 * speedFactor;
	water=	water - 0.02 * speedFactor;
	love	=	love  - 0.04 * speedFactor;
	
     // debug("Score: food: " + food + " water: " + water + " love: " + love);

	if(isDead()){
		if(useSound) playSound("sound_dead");
		showDead();
	} else {
		drawStatus();
		drawTiger();
	}
}


// =======================================
// DRAW METHODS
// =======================================

function drawStatus ()
{
     //debug("DrawStatus");

	var canvas  = document.getElementById("canvas");
	var context = canvas.getContext("2d");
	
	context.clearRect (0, 0, 272, 256);

	var startangle = 3.141592 / 2;
		  
	context.save();
	context.translate (272/2 - 2, 256/2 - 5);
	context.setLineWidth(3.0);

	// WATER
	var waterangle = (3.141592 * water) / 180.0;
	
	context.beginPath();
	context.arc(0, 0, 107.0, startangle, startangle + waterangle, 0);
	context.setStrokeColor(106.0/256, 131.0/256, 1, 1.0);
	context.stroke();
	startangle = startangle + waterangle;
	
	// FOOD
	var foodangle = (3.141592 * food) / 180.0;
	
	context.beginPath();
	context.arc(0, 0, 107.0, startangle, startangle + foodangle, 0);
	context.setStrokeColor(1, 1, 0, 1.0);
	context.stroke();
	startangle = startangle + foodangle;

	// LOVE
	var loveangle = (3.141592 * love) / 180.0;
	
	context.beginPath();
	context.arc(0, 0, 107.0, startangle, startangle + loveangle, 0);
	context.setStrokeColor(1, 0, 0, 1.0);
	context.stroke();

	context.restore();
}

function drawTiger ()
{
	var canvas  = document.getElementById("canvas");
	var context = canvas.getContext("2d");
		
	// BELLY
	if(food < 20){
			context.drawImage(hungry, 97, 122);
	}
	else if(food > 80){
			context.drawImage(full, 80, 111);
	}

	// EYES - KNIPPEREN
		if((food + water + love) % 10 > 1){
			if(love > 80){
				context.drawImage(eyesopenfull, 177, 74);
			} else {
				context.drawImage(eyesopenhalf, 177, 74);
			}
		}
	
	// MOUTH
		if(water < 20){
			context.drawImage(mouththirstyon, 192, 93);
		}else if(water < 40){
			if(water % 2 > 1){
				context.drawImage(mouththirstyon, 192, 93);
			} else {
				context.drawImage(mouththirstyoff, 192, 93);
			}
		}
		else if(water < 80){
				context.drawImage(mouththirstyoff, 192, 93);
		} 
		else context.drawImage(mouthhappy, 192, 93);

	// TAIL
		if((food + water + love) > 150){
			if(water % 2 > 1){
					context.drawImage(tailhappy, 36, 107);
			} else {
					context.drawImage(taillazy, 36, 110);
			}
		} else context.drawImage(taillazy, 36, 110);
 
}


// =======================================
// MOUSE METHODS
// =======================================

function mouseDown(event, tag)
{
	if(	event.target.src == "Images/buttonpressed.png");
		event.target.src = "Images/buttonpressed2.png";
	
	buttonPress(tag);

	event.stopPropagation();
	event.preventDefault();
}

function mouseUp (event, tag)
{
	if(	event.target.src == "Images/buttonpressed2.png");
		event.target.src = "Images/buttonpressed.png";
}	


function buttonPress(buttonTitle) {
		
	switch (buttonTitle) {
		
		case "w": 
			if(water < 110){
				water = water + 10;
				if(useSound) playSound("sound_water");
			} else {
				water = 120;
			}
			break;
			
		case "f": 
			if(food < 110){
				food = food + 10;
				if(useSound) playSound("sound_food");
			} else {
				food = 120;
			}
			break;
			
		case "l":
			if(love < 110){
				if(useSound) playSound("sound_love");
				love = love + 10;
			} else {
				love = 120;
			}
			break;
			
		case "a": 
			love = 0;
			break;
			
		case "minus":
			if(speedFactor < 0.1){
				speedFactor = 0.1;
			} else {
				speedFactor = speedFactor / 2;
			}
			break;
			
		case "plus":
			speedFactor = speedFactor * 2;
			break;
			
		case "reset":
				food  = 60;			// Food status, start at half
				water = 60;			// Water status, start at half
				love  = 60;			// Love status, start at half
				hideDead();
				if(useSound) playSound("sound_harp");
				break;
				
		default:
			return;
			break;
	}
		
}


 
// =======================================
// KEY METHODS
// =======================================
 
window.captureEvents(Event.KEYPRESS);
window.onkeydown = keyPressed;

function keyPressed(e) {

	var key = translateKey(e);
	// FOR FUTURE USE
}

function translateKey(e) {
	var key = String.fromCharCode(e.charCode);
	
	// post translation
	switch (key) {
		case "0":
			// RESET
			speedFactor = 2.0;
			break;
		
		case "-":
			// SLOW DOWN
			if(speedFactor < 0.1){
				speedFactor = 0.1;
			} else {
				speedFactor = speedFactor / 2;
				if(useSound) playSound("sound_click");
			}
			break;
		
		case "=":
			// SPEED UP
			speedFactor = speedFactor * 2.0;
			if(useSound) playSound("sound_click");
			break;
	}

	return key;
}




// =================================
// TONEN EN VERBERGEN VAN VOORKEUREN
// =================================

// showPrefs() wordt opgeroepen als op het i icoontje wordt geklikt. 
// Het bevriest de voorkant van de widget, verbergt de voorkant,
// toont de acterkant en draait de widget dan om.

function showPrefs()
{
	if(useSound) playSound("sound_satori");

	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
     // bevries de widget zodat er geen veranderingen kunnen optreden zonder dat 
	// de gebruiker dit merkt.
	if (window.widget)
		widget.prepareForTransition("ToBack");		
	
	front.style.display="none";		// verberg de voorkant
	back.style.display="block";		// toon de achterkant
	
	// draai de widget om
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	

	// ruim de voorkant op - verberg de cirkel achter de i knop	document.getElementById('fliprollie').style.display = 'none';  

}


// hidePrefs() wordt opgeroepen als op de done button op de achterkant wordtgeklikt. 
// het voert de omgekeerde elementen uit als showPrefs() doet.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		
	
	back.style.display="none";		// verberg de achterkant
	front.style.display="block";	// toon de voorkant
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		
}



function showDead()
{

	var front = document.getElementById("front");
	var back = document.getElementById("theend");
	
     // bevries de widget zodat er geen veranderingen kunnen optreden zonder dat 
	// de gebruiker dit merkt.
	if (window.widget)
		widget.prepareForTransition("ToBack");		
	
	front.style.display="none";		// verberg de voorkant
	back.style.display="block";		// toon de achterkant
	
	// draai de widget om
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	

	clearInterval(timerInterval);

}



function hideDead()
{
	var front = document.getElementById("front");
	var back = document.getElementById("theend");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		
	
	back.style.display="none";		// verberg de achterkant
	front.style.display="block";	// toon de voorkant
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		
	timerInterval = setInterval("updateScore(true);", 1000);

					
}



// VOORKEUREN BUTTON ANIMATIE (fade in/out)

var flipShown = false;		
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

// mousemove() is gekoppeld aan de onmousemove eigenschap van de voorkant div van de widget. 
// het wordt aangeroepen wanneer de muis wordt bewogen binnen het oppervlakte van uw widget Het bereid
// de voorkeuren flipper fade en roept dan animate() aan om de animatie uit te voeren.

function mousemove (event)
{
	// als de voorkeuren flipper al niet getoond is...
	if (!flipShown)			
	{
		if (animation.timer != null)			
		{
			// reset de animatie timer waarde, in het geval er een waarde achter was gebleven			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 			// zet 1 frame terug
		
		animation.duration = 500;												
		// animation tijd, in ms
		animation.starttime = starttime;						// specificeer de start tijd
		animation.firstElement = document.getElementById ('flip');		// specificeer het element om te faden
		animation.timer = setInterval ("animate();", 13);		// specificeer de animatie functie
		animation.from = animation.now;						// begin opacity (niet per se 0)
		animation.to = 1.0;								// eind opacity
		animate();										// begin animatie
		flipShown = true;									// markeer de flipper als geanimeerd
	}
}

// mouseexit() is de tegenhanger van mousemove(), het bereid de flipper voor om te verdwijnen.
// het voegt de juiste waarden to aan de animatie data structure en zet de animatie in beweging. 

function mouseexit (event)
{
	if (flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() voert de animatie uit voor de voorkeuren flipper. Het gebruikt de opacity CSS eigenschap
// om de fade te simuleren.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// deze hulpfuncties worden gebruikt door animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// deze functies worden aangeroepen als de info button zelf een onmouseover of onmouseout event ontvangt.

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}


// PREFERENCE
function SoundButtonChecked(button){

	var sound = document.settings.sound.checked;
	if (window.widget){
		if(sound){
			 widget.setPreferenceForKey("usesound", "playsound");
		}
		else{
			widget.setPreferenceForKey("dontusesound", "playsound");
		}
	}

	useSound = sound;
}

function clickedLink(section){ 
	if (window.widget) widget.openURL('http://www.mekentosj.com/widgets/tigergotchi'); 
}


function debug(msg) {
	if (!debug.box) {
		debug.box = document.createElement("div");
		debug.box.setAttribute("style", "background-color: white; " +
										"font-family: monospace; " +
										"border: solid black 3px; " +
										"position: absolute;top:300px;" +
										"padding: 10px;");
		document.body.appendChild(debug.box);
		debug.box.innerHTML = "<h1 style='text-align:center'>Debug Output</h1>";
	}
	
	var p = document.createElement("p");
	p.appendChild(document.createTextNode(msg));
	debug.box.appendChild(p);
}
